# 1 "bootsector.S"
  

.code16			 

.text			 
.globl	_start		 

 

_start:					 

wait_floppy_off:				 

	mov     $0x3f1, %dx
	inb     %dx , %ax
	and	$0x01, %ax
	jne	wait_floppy_off

motor_on:
	mov 	$0x3f2, %dx			 
	mov 	$0x04, %ax
	outb    %al, %dx 	
	mov 	$0x3f2, %dx			 
	mov 	$0xf0, %ax
	outb    %al, %dx 			 

 
        mov     $0x03 , %ah			 
        xor     %bh , %bh
        int     $0x10
        mov     $0x0300 , %cx			 
        mov     $0x07 , %bx       			
        mov     $0x7c40 , %bp			 
        mov     $0x1301 , %ax          			
        int     $0x10					

 
        xor     %ax, %ax
        mov     %ax , %ds
        mov     %ax , %es
        mov     $0x700 , %ax 		 
        mov     %ax , %ss
        mov     $0xC00 , %sp
        mov     %dl , boot_drive         

 
	mov 	$0x12 , %ax		 
        mov     $0x07E0 , %cx	
        mov     %cx , %es
        mov     $0x08 , %cl         	 
        xor     %ch , %ch
        call    read_sectors		 

 
        mov     $0x03 , %ah			 
        xor     %bh , %bh
        int     $0x10
        mov     $0x0600 , %cx			 
        mov     $0x07 , %bx       			
        mov     $0x7c40 , %bp			 
        mov     $0x1301 , %ax          			
        int     $0x10					

blazz:
	nop
	nop
					 
	cli				 
	mov	$0x1, %eax		 
	mov	%eax, %cr0		 
	jmp  IA32			 
IA32:
	nop
	nop
	jmp IA32  

 

read_sectors:

        mov     (sectors) , %ax
        sub     (sector) , %ax         
        cmp     %cx , %ax         	 
        jb      lab_1
        mov     %cx , %ax

lab_1:  mov     %es , %bx           
        mov     %bx , %dx
        shr     $0x12 , %dx           
        shl     $0x12 , %dx
        add     $0x1000 , %dx
        sub     %bx , %dx           
        shr     $0x5 , %dx
        cmp     %dx , %ax           
        jb      lab_2
        mov     %dx , %ax
lab_2:
        call    read_track
        sub     %ax , %cx

        mov     %ax , %dx          
        shl     $0x5 , %dx
        mov     %es , %bx
        add     %dx , %bx
        mov     %bx , %es

        add     (sector) , %ax      
        cmp     (sectors) , %ax
        jb      lab_3
        xor     %ax , %ax           
        incw 	head
        cmpw 	$0x0002 , head
        jb      lab_3
        movw 	$0x00 , head       
        incw 	track
lab_3:
        mov     %ax , sector
        or      %cx , %cx
        jnz     read_sectors
        ret

read_track:
 
        pusha
        mov     $0x08 , %cx           
retry:
        push    %ax
        push    %cx
        xor     %bx , %bx
        mov     (sector) , %cl
        inc     %cl               
        mov     (track) , %ch
        mov     (boot_drive) , %dl
        mov     (head) , %dh
        mov     $0x02 , %ah
        int     $0x13
        jc      error
        add     $0x04 , %sp          
        popa
        ret
error:
        pop     %cx
        pop     %ax
        loop    retry
hang:   jmp 	hang		 

endcode:				 
splash:
	.byte 10,13
	.byte 10,13
	.byte 10,13
	.ascii "cLIeNUX Bootsector."
	.byte 10,13

	.byte   0xb0
	.byte   0xb0
	.byte   0xb0
	.byte   0xb0
	.byte   0xb0

.org 	500
sectors:
	.byte 0x0
boot_drive: 
	.byte 0x0
sector:
	.word  0x0000
head:
	.word  0x0000
track:
	.word  0x0000	

.org 	510
boot_flag:
	.word 0xAA55
stage_2:

 

