/* hexpad
Copyright 1999 Richard Allen Hohensee
This File is released for redistribution only as part of an intact 
entire cLIeNUX Core

make the Linux console compose-key table a flat nybble-input
	hexadecimal array, for generality, hexpad input, etc.  
*/


#include <fcntl.h>
#include <linux/types.h>
#include <sys/ioctl.h>
#include <ctype.h>
#include <linux/kd.h>


#if 0
/* pasted from <linux/kd.h>, for documetratials

struct kbdiacr {
        unsigned char diacr, base, result;
		};

struct kbdiacrs {
        unsigned int kb_cnt;    /* number of entries in following array */
	struct kbdiacr kbdiacr[256];    /* MAX_DIACR from keyboard.h */
		};

#define KDGKBDIACR      0x4B4A  /* read kernel accent table 	*/
#define KDSKBDIACR      0x4B4B  /* write kernel accent table 	*/
#endif



/* if you prefer uppercase A-F or something, here's your keys.  This is
all turned on by the Compose key, which is independant of this. 
It looks like both-case a-F would need 512 entries. */

unsigned char  nybble[] = { '0', '1', '2', '3', '4', '5', '6', '7',
			     '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' }; 	




int  main()		/* runtime beings here  */
{
struct kbdiacrs triples;


int i, j, k ;

triples.kb_cnt = 16 * 16 - 1 ;


for (i = 0;i < 16 ;i++)		/* build table */
	{ 
	for (j = 0;j < 16;j++)
		{
		k = (i << 4 ) + j ;
            	triples.kbdiacr[k].base    = j;
            	triples.kbdiacr[k].diacr   = i;
            	triples.kbdiacr[k].result  = k;
		}
	}		
						/* pass it to Linux */
        if (ioctl (1, KDSKBDIACR, &triples) )	  	/* the crux */ 
		{
            	write(2,"ioctl KDSKBDIACR failed 	\n",37 );
            	exit(-22);
        	}
return 0;
}
