
                             The Hayes Command Set
                                       
   This file concludes with a listing of the Basic and Extended Hayes
   Command Set.. It begins with an explanation of what these command sets
   are. The modem initialization string consists of a series of commands.
   It prepares the modem for communications, setting such features as
   dialing mode, waits, detection of the busy signal and many other
   settings. Newer modem communications programs reset the
   initializations string for you according to which menu options you
   select, which features you enable. For many years Hayes modems have
   been the standard in modems. As the field of modem manufactures has
   grown, most have adhered at least losely to the Hayes standard. The
   following is a partial list of the Hayes command set. (called the AT
   commands). The Hayes Command Set can be divided into three groups:
   
   Basic Command Set
          A capital character followed by a digit. For example, M1.
          
   Extended Command Set
          An "&" (ampersand) and a capital character followed by a digit.
          This is an extension of the basic command set. For example,
          "&M1". Note that "M1" is different from "&M1".
          
   Register Commands
          Sr=n where "r" is the number of the register to be changed and
          "n" is the new value that is being assigned.
          
   A "register" is computerese for a specific physical location in
   memory. Modem have small amounts of memory onboard. This third set of
   commands is used to enter values in a particular register (memory
   location). The register will be storing a particular "variable"
   (alpha-numeric information) which is utilizedby the modem and
   communication software. For example, S7=60 instructs your computer to
   " Set register #7 to the value 60."
   
   Here are some of the most important characters that may appear in the
   modem initialization string. These characters normally should not be
   changed.
   
   AT
          tells the modem that modem commands follow. This must begin
          each line of commands.
          
   Z
          resets the modem to default state
          
   ~ (tilde)
          makes your software pause for half a second. You can use more
          than one ~ in a row. For example, "~~~~" tells the software to
          pause two seconds.
          
   ^M
          sends the terminating Carriage Return character to the modem.
          This is a control code that most communication software
          translate as a "carriage return."
     _________________________________________________________________
   
Ask your modem

   Seriously, nothing knows better than your modem which commands it
   accepts and how it interprets them. These commands are stored in
   yourmodems ROM (Read Only Memory) and you can ask your modem to list
   them. In fact, the list of commands concluding this file is what my
   USR 14, 400 Sportster gave to me. Here are some of the Help Commands
   included in the Command Set:
   
   AT$
          HELP, Command Quick Reference (CTRL-S to Stop, CTRL-C to
          Cancel)
          
   &$
          HELP, Ampersand Commands
          
   D$
          HELP, Dial Commands
          
   S$
          HELP, S Registers
          
   AT&$
          HELP, Ampersand Commands
     _________________________________________________________________
   
The Basic Hayes Command Set - Alphabetical

   AT$
          HELP, Command Quick Reference (CTRL-S to Stop, CTRL-C to
          Cancel)
          
   &$
          HELP, Ampersand Commands
          
   A/
          Repeat last executed command. Use primarily to redial, AT nor
          [Rtrn] required
          
   AT
          Required Command mode prefix (Attention Modem)
          
   A
          Answer Call
          
   Bn
          n=0 V32 Mode/CCITT ans Seq
          n=1 Bell Answer Seq
          n=2 Verbose/Quiet On Answer
          
   Dn
          Dial a Telephone Number
          n=0..9#*TPR,;"W@!()-
          
   DL
          Dial Last Phone Number
          
   DSn
          Dial Stored Phone Number
          
   D$
          HELP, Dial Commands
          
   En
          n=0 No Command Echo
          n=1 Echo Command Chars
          
   Fn
          n=0 Online Echo
          n=1 No Online Echo
          
   Hn
          n=0 On Hook (Hang Up)
          n=1 Off Hook
          
   In
          n=0 Product Code
          n=1 Checksum
          n=2 RAM Test
          n=4 Current Settings
          n=5 NVRAM Settings
          n=6 Link Diagnostics
          n=7 Product Configuration
          
   Ln
          n=0 Low Speaker Volume
          n=1 Low Speaker Volume
          n=2 Med Speaker Volume
          n=3 Hi Speaker Volume
          
   Mn
          n=0 Speaker Off
          n=1 Speaker OnUntil CD
          n=2 Speaker Always On
          n=3 Speaker Off During Dial
          
   On
          n=0 Return Online
          n=1 Return Online & Retrain
          
   P
          Pulse Dial
          
   Qn
          n=0 Result Codes Sent
          n=1 Quiet (No Result Codes)
          
   Sr=n
          Sets Register "r" to "n"
          
   Sr?
          Query Register "r"
          
   S$
          HELP, S Registers
          
   T
          Tone Dial
          
   Vn
          n=0 Numeric Responses
          n=1 Verbal Responses
          
   Xn
          n=0 Basic Result Codes
          n=1 Exended Result Codes
          n=2-4 Advanced Result Codes
          
   Yn
          Select power on/reset default configuration
          n=0 Next reset to &W0 settings
          n=1 Next reset to &W1 settings
          
   Zn
          Reset modem based on current DIP switch settings
          n=0 Dipswitch #7 determines reset
          n=1 Reset to &W0 settings
          n=2 Reset to &W1 settings
          n=3 Reset to &F0 settings
          n=4 Reset to &1 settings
          n=5 Reset to &F2 settings
          
   +++
          Escape Code
     _________________________________________________________________
   
The Extended Hayes Command Set (Ampersand Commands )

   AT&$
          HELP, Ampersand Commands
          
   &An
          n=0 Disable /ARQ Result Codes
          n=1 Enable /ARQ Result Codes
          n=2 Enable /Modulation Codes
          n=3 Enable /Extra Result Codes
          
   &Bn
          n=0 Floating DTE Speed
          n=1 Fixed DTE Speed
          n=2 DTE Speed Fixed When ARQ
          
   &Cn
          n=0 CD Always On
          n=1 Modem Controls CD
          
   &Dn
          n=0 Ignore DTR
          n=1 On-Line Command Mode
          n=2 DTE Controls DTR
          
   &Fn
          n=0 Load Factory 0, no FC
          n=1 Load Factory 1, HW FC
          n=2 Load Factory 2, SW FC
          
   &Gn
          n=0 No Guard Tone
          n=1 550 Hz Guard Tone
          n=2 1800 Hz Guard Tone
          
   &Hn
          n=0 Disable TX Flow Control
          n=1 CTS
          n=2 Xon/Xoff
          n=3 CTS and Xon/Xoff
          
   &In
          n=0 Disable RX Flow Control
          n=1 Xon/Xoff
          n=2 Xon/Xoff Chars Filtered
          n=3 HP Enq/Ack Host Mode
          n=4 HP Enq/Ack Terminal Mode
          n=5 Xon/Xoff for non-ARQ Mode
          
   &Kn
          n=0 Disable Data Compression
          n=1 Auto Data Compression
          n=2 Enable Data Compression
          n=3 Selective Data Compression
          
   &Mn
          n=0 Normal Mode
          n=4 ARQ/Normal Mode
          n=5 ARQ Mode
          
   &Nn
          n=0 Highest Link Speed
          n=1 300 bps
          n=2 1200 bps
          n=3 2400 bps
          n=4 4800 bps
          n=5 7200 bps
          n=6 9600 bps
          n=7 12000 bps
          n=8 14400 bps
          
   &Pn
          n=0 N.American Pulse Dial
          n=1 UK Pulse Dial
          
   &Rn
          n=1 Ignore RTS
          n=2 RX to DTE/RTS high
          
   &Sn
          n=0 DSR Always On
          n=1 Modem Controls DSR
          
   &Tn
          n=0 End Test
          n=1 Analog Loopback (ALB)
          n=3 Digital Loopback (DLB)
          n=4 Grant Remote DLB
          n=5 Deny Remote DLB
          n=6 Remote Digital Loopback
          n=7 Remote DLBWith Self Test
          n=8 ALB With Self Test
          
   &Wn
          n=0 Store Configuration 0
          n=1 Store Configuration 1
          
   &Yn
          n=0 Destructive
          n=1 Destructive/Expedited
          n=2 Nondest./Expedited
          n=3 Nondest./Unexpedited
          
   &Zn=s
          Store Phone Number
          
   &Zn?
          Query Phone Number
     _________________________________________________________________
   
Do You Know Something We Should Know?

   If you have a command which 1) We don't have listed. 2) Which does
   something differently on your modem , then we would really like to
   here from you! Please send mail to userhelp. Please include how to
   contact you, the modem you are using, and the software. Are you ready
   to mail us?
