NAME - dcon    minimalist complete comms-oriented scripting language

PAGEDATE  19980103-19980203

DESCRIPTION

dcon was written entirely for expedience in a paid-consultant setting for
managing communications tasks. It is similar to a tiny BASIC, with unix
task control, file access, and handlers for a single active com device.
It's also small in RAM. It's features are very limited, but remarkably
complete. It is therefor easy to learn.  It can deal with multiple
expected responses from the com device, can call any command, can fork
itself, and knows about most of what a unix task consists of.  It has
complete but minimal sets of integer and string operators, conditionals,
flow control, and file access facilities, relying on BASIC-style goto,
gosub, $mid(), and so on. An instance of dcon can have one open com device
and one open file (besides stdin, stderr, stdout). 

dcon should be considered in lieu of dip, kermit, expect, etc. and is also
an alternative to sh scripts, perl, tcl etc. for simple tasks. The cLIeNUX
programming seedoc is based on dcon due to it's simplicity and clarity.

USE - typical

"WAAAAAAAAAAHHHH!!! How do I connect Linux via PPP? chat doesn't work!" 
chat works, but I don't know how. I couldn't get it to flicker my modem
lights.  The author says dcon is easy.  They all say that. dcon IS
relatively easy.  Incredible.  Modify the example script included in the
dcon.doc ( and separately) for your self and your ISP. Note that you don't
necessarily have to wait for a particular string from the other end;
sometimes just waiting a few seconds will work fine.  In re CHAP,
proprietary ISP stuff, etc., dcon can call any unix command.

USE - general scripting
a "hello world" script, try it......

#!/usr/sbin/dcon
print "Hello world. I'm a dcon script :o)\n"

USE - semi-interactive

dcon -s '<return>
<lines of dcon >
<lines of dcon >
'

cheatsheet....

Integer variables are single lower-case letters. String variables are e.g.
$a . 

Operator  Description      Example           Result
+         Addition         let a=2+2         4
+         Concatenation    let $b="aa"+"bb"  "aabb"
-         Substraction     let e=2-5         -3
*         Multiplication   let f=11*2        22
/         Division         let g=34/11       3
&         Bit-Wise AND     let h=42&7        2
|         Bit-Wise OR      let a=42|5        47
^         Bit-Wise XOR     let a=42^7        45
precedence, none. use parens or do things in strict left-to-right order.                                                                                             

index, tokens/keywords in asciibetical order 		
:		- flow control target  e.g.    :myroutine
!=		- not equals comparison, if a!=4     or    if 1+3+d!=n 
<		- less than comparison
=		= equals comparison
>		- greater than  comparison
		the comparisons just happen to ascii sort together here, and work
		on strings also.
atol		- ascii to long int
baud		- let b=baud()     speed of the com line    see also $baud()
		-  let $s=$baud()   string form of above
cd		- cd "pathname"
clocal		-  set clocal
close		- close "open"ed file
com		- "set" variable, e.g.            set com 38400n81
comecho		- "set" variable, on|off   echos other end
cwd		- pwd sorta,  let $w=$cwd()
dec		- dec a       like a--
dev		- pathname of current com device     let $m=$dev()
echo		- set echo on|off   
else		- do the following if last if tested false
env		- e.g.   let $e=$env("PATH")
eprint 		- like print but to stderr ( redundant with fprint. handy, tho.)
exec		- replace current process with new one   exec "cmd  args"		
exit		- e.g.     exit 0       is die with error=false
fork		- as per unix usual. child returns 0, parent returns pid ( of child?) in %
fprint  	- like print, but to fid     fprint fid printargs
get		- syntax    get  timeoutsecondsfloat  "terminate_chars" $a
gosub		- just like BASIC,  with   return .  e.g.  gosub routine  ( no : )
goto 		- it's in the examples, but grep token didn't hit it. ?
hms		- hours:minutes:seconds  time thingies seem to be a separate number space
hset		- e.g.     hset 0    resets hundreths timer, see htime
htime		- let x=htime()        x will be hundreths of seconds in life of script
if 		- e.g.   if n=120  print "yup. n = 120 :0)\n"
ignorecase 	- set ignorecase on|off    for waitfor
inc		- inc a        like a++
input		- e.g.    input $a         from keyboard      pretty BASIC :o)
kill		- kill #    # is an int
len		- let x=len($a)   $a is a string var, x is an int
let		- let a=5       let $a="stringggggggg"
lprint		- print a "log entry" to stderr 
mid		- BASIC mid,   let $c=$mid($s,s,4)  s=start, 4 =len    from 0  
off		- boolean value for severals comms/set variables
on 		- boolean value for severals comms/set variables   
open   		- open file
pid		- let x=pid()     our process ID number
ppid		- let p=ppid()       our parent's pid
print		- print a comma-separated list    print $a,$q," stuff\n"
putenv		- set an environment variable     
rem 		- doncha LOVE it?  # and //  work too. rem needs a trailing space.	
return		- return to just below calling gosub 
rpipe		- Description : Returns the first line from a system piped command
		Syntax      : let $x=$rpipe("/bin/ls |grep myfile")
		Notes       : Not very useful unless used with head, tail, grep, etc...               
			( this is interesting though. rick)
send		- send string to com line
senddelay  	- set senddelay TIME_constant    char delay for   send
set		- echo, comecho, ignorecase, clocal, verbose on|off;senddelay, umask, com 
sleep		- 1/100 second resolution to 100 seconds, 1 second from there
system 		- system "unix_command"
testkey		- can only test for ENTER. this is in Chouinard's todo's.
time		- unix era time in seconds         let x=time()
		-  let $s=$time()    24 charachter local time
umask		- set umask octal_constant
val		- let s=val($s)    looks like intstring to int
verbose		- set verbose on|off
wait		- wait on child 
waitfor		- wait for string    waitfor timeout "stirng", "strng",... returns an int
waitquiet	- wait_till_quiet really,  waitquiet timeout quiescence_time


SEE ALSO
dcon.doc  is complete, full of examples, and hilarious. 

AUTHOR
dcon is copyright 1989, 19967 Daniel Chouinard. It is released with a few 
restrictions concerning changing the syntax of dcon. The release is in
dcon.doc .  danny@limestone.kosone.com

PAGE AUTHOR
Rick Hohensee  rickh@capaccess.org
