/* sorta unpack a Plan9 archive with the "/wrap" format stuff in it.
Based on cLIeNUX buffered_traversal.c. 

interface: reads stdin. Makes a mess in the current directory. 

Probably requires GNU cc for dereferenced lvalues. This is to make one
pass over stdin, building state as we go without "rewinding".

July 2000 Rick Hohensee
					*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#define READSIZE 	(1 << 18)
#define ITEMSIZE 	(1 << 9)
#define DEBUGGING

#define NEWLINE		10	/* unix newline */
#define SPACE		32
#define SLASH		47

int absolute, cursor, buffersize, pathlength;
unsigned char this, delimiter;


/* Hey, how 'bout you just gimme a local native machine int representing
	some memory? 							*/

char buffer[READSIZE], linea[READSIZE], patha[ITEMSIZE],
	permsa[ITEMSIZE], capesa[ITEMSIZE], ownera[ITEMSIZE],
	sizea[ITEMSIZE], spama[ITEMSIZE], parenta[ITEMSIZE],
	legacya[ITEMSIZE] ;

int line = (int)&linea, path = (int)&patha, perms =(int)&permsa, 
	capes = (int)&capesa, owner = (int)&ownera, size = (int)&sizea, 
	spam = (int)&spama, parent = (int)&parenta, 
	legacy = (int)&legacya ;

/* Thanks. :o)      */



int 
		more ()			/* read next bufferfull */ 
{
	int got;
	cursor = 0;
	got =  read(0,buffer,READSIZE);
	if ( got == 0 )			/* this could be higher up*/
		{ exit (0); }
	return got;
}
			

			/*
		Return next byte or quit. Uses un-passed globals.
				*/
char
		step ()	
{
	int got;
	if (cursor == buffersize)
		{ got = more ();
		if (got < READSIZE)
			{ buffersize = got ; }		
		}
	absolute++;
	return buffer[cursor++];
}

			/* 
	Tokenize up to a delimiter, zero-terminate token in dest buffer. 
	libc then applies. This part is hardwired to the buffering wrapper,
	in that it rolls the main cursor forward un-rewindably.  
	Return length of string, -1, or quit. 
				*/
int					
		snip (int dest, char delimiter, int atmost)
{
	int localcursor=0;
	while (localcursor < atmost)
		{ this = step();
		if ( this > 128 ) return -1;
		if (this == delimiter)
			{ *(char *)(dest + localcursor) = 0 ;  
			return localcursor ;			
			}
		else	{ *(char *)(dest+localcursor) = this; 
			}
		localcursor++;
		}
	return -1;		/* Didn't delimit within atmost. */
}



				/* return 0 if zehr gut		*/
int 
		fileline () 
{
		/* quit munching on first failure	*/
	pathlength = snip(path,SPACE, 200);
	if (-1  == pathlength ) return -1;
	if (-1  == snip(perms, SPACE, 14)  ) return -1;
	if (-1  == snip(owner, SPACE, 50)  ) return -1;
	if (-1  == snip(spam, SPACE, 200)  ) return -1;
	if (-1  == snip(capes, SPACE, 10)  ) return -1;
	if (-1  == snip(size, NEWLINE, 30) ) return -1;
return 0;
}



		/*
	Returns parent namestring of a path. Uses globals "path"
	and "pathlength".
		*/
int					
		Parentof ()
{
	int i;
	for ( i = 0;i < pathlength; i++)		/* copy	*/
		{ *(char *)(parent+i) = *(char *)(path+i);	
		}
	for ( i = pathlength; i ; i--)		 	/* clip */
		{ if ( *(char *)(parent+i) == SLASH )
			{ *(char *)(parent+i) = 0 ;
			return i  ;
			}
		}
return -1;
}


				/*    archive to plain file */
void
		copy ()
{
	int cfd, got, remaining, bufferleft ;
	unsigned short mode;
	got = more();
	remaining = atoi((char *)size);
	mode = atoi((char *)perms);
	cfd = creat(path, mode);
	if ( cfd == -1 ) printf("BONK on creat %s \n", (char *)path);
			
	while ( remaining > 0 )
		{ bufferleft = READSIZE - cursor;
		if ( remaining - bufferleft > 0 )
			{ write(cfd,buffer, bufferleft);
			remaining = remaining - bufferleft ;
			got = more() ;
			}	
		else	{ write(cfd,buffer, remaining); 
			close(cfd);
			return ; 
			}
		}
}


			/* mkdir -p in it's own cooking bag */
void
		lineage () 
{
	int i=0, orphan=0;
		
	while ( *(char *)(parent+i) != 0 )
		{
		if ( *(char *)(parent + i) != *(char *)(legacy + i) )
			{ orphan = 1 ;
			*(char *)(legacy + i) = *(char *)(parent + i);
			}
		if (( *(char *)(parent + i) == SLASH) && (orphan == 1) )
			{ *(char *)(legacy + i) = 0 ;
			mkdir(legacy, 0);
			*(char *)(legacy + i) = SLASH ;
			orphan = 0;
			}
		i++;
		}
}





		/*
	Linux exit() returns a char to the caller.
			*/
char
		main ()	
{				/* init 	*/
buffersize = READSIZE ;
more();

		/*
	Testtesttest till file-line, then do copy, then back to the top. 
	All test fails start at the top while 1==1.
			*/
while ( 1 == 1 )
	{ this = step();
	if (this == NEWLINE)
		{ this = step();
		if (this == SLASH)
			{ if ( 0 == fileline() )	
				{ if ( 0 != atoi( (char *)size ) ) 
					{ Parentof();
					lineage();
					copy();
					}
				else	{ if ( pathlength < 40 )
						{ mkdir(path,0);
						} 
					}
				}
			}
		}
	}
}


/*

gcc -Wall -O -s -o unpackp9 p9unpack.c
d -l --color unpackp9

*/
