/* <pre> cLIeNUX tally

NAME
tally -  running total occurances of each possible byte value in file(s)

DESCRIPTION
 Handy for designing keymaps, possibly for other investigations.  tally
runs pretty quickly. What tally does is very simple and easy for a
computer. Note that tally itself doesn't, traverse, uncompress or
unarchive. All args to tally are files to be processed. Shell expansion
applies. Output is to stdout. This first version doesn't use stdin. So-o,
can be used with advantage like... 

	tally hello.c
	tally `find . -name "*.[ch]" ` | sort -nr |less 

et cetera. The tab-delimited fields in tally's output are...

     occurances count,  which byte #,  byte as ASCII,  percentage

...which facilitates sorting by prevalence.

SEE ALSO; ascii, wc

BUGS  see below
*/


/* from   see open   */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <unistd.h>

int i, j, fd, errno, 	/* phonetic past tense of read */ red;
unsigned int  count[256];
unsigned char buffer[4096];	 	/* Linux likes this size */	
float total;


void report(){		/*  output results to stdout (i.e. print) */ 
for (i = 0; i < 256 ; i++)		/* one-liner loop for a total */
	total = total + (float)count[i];

for (i = 0; i < 256 ; i++)		/* for each possible byte value */
	{ 
	printf ( "%d\t%d\t" , count[i], i );	
	if ( isprint(i))			/* output ASCII or output
						unprintables as  [number] */
		{ printf ( "%c\t", i );
		}
	else 	{ printf("[%d]\t", i);
		}
	printf("%2.2f %%", ( (float) count[i] / total ) * 100.0 );
	printf("\n");
	}
}


int main (int argc, char  *argv[])	/* program starts running here. */
{
for ( i = 1 ; i < argc ; i++)		/* all args are files, no switches */
	{
	fd = open( argv[i], O_RDONLY );
	red = -2 ;
	while ( red )			/* buffer IO sans libc. pththtp  */
		{
		red = read(fd, buffer, 4096);
		if ( red == -1 )
			break ;

		  /* the crux of the biscuit, increment a byte's count  */ 	
		for (j = 0 ; j < red ; j++)
			{ count[ buffer[(unsigned int)j] ] ++ ; 
			}
		}
	} /* end files loop */

report();	/* output results to stdout */
return 0; 	/* turn off some compiler warning noise */
} 		/* end of main, end of program code  

RIGHTS
Copyright 1999 Richard Allen Hohensee
Public domain. Please make some significant improvement before you claim or
re-name. Use of stdin, for example.
*/
