/*
	xgapos.c

	I don't need the entire xf86config, so I grabbed the appropriate
	chunks of Anders' xf86config mods, hacked some of the extraneous
	stuff out (/proc/mca/pos usually doesn't change after boot, for
	example, and some sscanf magic), and made it dump the important
	stuff - the device section.  Plus a bugfix (which he didn't
	encounter 'cause his adapter is in the last slot checked).

	You may have to change the chipset value for some XGA-1 cards -
	I know mine works, but there may be others.

	Chris Beauregard (chrisb@truespectra.com)

modified for multiple cards by Edmund Shwayri
mutated to check a specific slot, output in shell variable-assignment format,
	cretinize the code some, other oddities...
	Rick Hohensee humbubba@smart.net

*/

#include <stdio.h>
#include <stdlib.h>

int
main(int argc, char * argv[]) {
  /*
   * This part was made by Anders Johansson <Anders.Johansson@uab.ericsson.se>
   * This has only been tested on a IBM 9557 (486SLC-2/50 with onboard XGA-2)
   * but should hopefully work with all MCA XGA-2 and probably also XGA-1
   * This needs the MCA patch for 2.0.7 kernel from 1 Sep 96. (or at least
   * the same format for the /proc/mca/pos file.
   */
const char* const mca_file = "/proc/mca/pos";
int i,j;
char ch;
FILE* proc_mca;
int  posreg0;  
int  posreg1;  
int  posreg2;  
int  posreg3;  
int  posreg4;  
int  posreg5;  
int  posreg6;  
int  posreg7;  
char tmp[80];
  
int Instance,IObase,COPbase,MEMbase,BIOSbase;
  

if (argc != 2) {
	printf(" 
	USAGE:  progname slot
		where slot is 1 through 8 or p for planar
	\n");
	printf(" %d \n", argc );
 	return -1 ;
	}

if( (proc_mca = fopen( "/.pro/mca/pos","r") )== 0)
    { printf("  /.pro/mca/pos was not found. Need that.  \n");
      return 1;
    }


      	/* slurp off preceeding slots */
i = 1;	/* slots are numbered from one */
do {	printf("\n%d      ", i );
	fgets(tmp,80,proc_mca);
	sscanf(tmp,"%*[^:]: %x %x %x %x %x %x %x %x ",
		&posreg0,&posreg1,&posreg2,&posreg3,&posreg4,
		&posreg5,&posreg6,&posreg7);

	printf(" %x %x %x %x %x %x %x %x ",
		posreg0,posreg1,posreg2,posreg3,posreg4,
		posreg5,posreg6, posreg7);

	i++;
	} while(i <=  atoi(argv[1]) ) ;





Instance = (posreg2 & 0xe) >> 1;
IObase = 0x2100 + (Instance << 4);
MEMbase = (posreg4 & 0x000000fe) * 0x1000000 + (Instance << 22);
COPbase = 0xc1c00 + (((posreg2 & 0xf0) >> 4) * 0x2000) + (Instance * 0x80);
BIOSbase = 0xc0000 + (((posreg2 & 0xf0) >> 4) * 0x2000);

printf("    
Instance=%d
IObase=0x%x    
COPbase=0x%x    
MEMbase=0x%x
BIOSbase=0x%x
", 
Instance, IObase,COPbase, MEMbase,BIOSbase);   
}
